---
title: XRBoundedReferenceSpace.boundsGeometry
slug: Web/API/XRBoundedReferenceSpace/boundsGeometry
tags:
  - API
  - AR
  - Boundary
  - Edges
  - Geometry
  - Property
  - Read-only
  - Reality
  - Reference
  - VR
  - Virtual
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - XRBoundedReferenceSpace
  - augmented
  - boundsGeometry
  - space
---
<p>{{APIRef("WebXR Device API")}}{{secureContext_header}}{{draft}}</p>

<p><span class="seoSummary">The read-only {{domxref("XRBoundedReferenceSpace")}} property <code><strong>boundsGeometry</strong></code> is an array of {{domxref("DOMPointReadOnly")}} objects which specifies the points making up a polygon inside which the viewer is allowed to move.</span> Each point is treated as a two-dimensional point, and must be located at ground level (that is, its <code>y</code> coordinate must be 0).</p>

<p>This boundary is typically configured by the user, using the software that controls their XR hardware. This may be done by walking the border of the space they wish to use, or by drawing the shape of their room using their XR input device. Theoretically, a more advanced system might use sensors or other detection methods to determine the bounds of a dedicated XR room (notice how we carefully don't call it a holodeck?).</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><em>bounds</em> = <em>xrReferenceSpace</em>.boundsGeometry;</pre>

<h3 id="Value">Value</h3>

<p>The <code>boundsGeometry</code> property is an array of {{domxref("DOMPointReadOnly")}} objects, each of which defines one vertex in a polygon inside which the viewer is required to remain. Each point must be at floor level, with its <code>y</code> coordinate's value set to 0. Additionally, the value of <code>w</code> is always 1 in every point in the array. Additionally, the points <em>must</em> be listed in clockwise order.</p>

<p>Each entry in <code>boundsGeometry</code> is equal to an entry in the list of native bounds geometry points for the room, premultiplied by the inverse of the origin offset. In other words, the bounds are the physical limitations of the available space, shifted so that the reference space's bounds points are all defined relative to the <code>XRBoundedReferenceSpace</code>'s effective origin.</p>

<h2 id="Usage_notes">Usage notes</h2>

<p>Bounded reference spaces always have their origin located at ground level, where <code>y</code> is 0. As a general rule, with the origin for <code>x</code> and <code>z</code> located in or near the center of the space, and with the orientation set facing in a logical forward direction, as appropriate for the underlying platform or XR hardware.</p>

<p>In order to reduce the risk of the room boundaries being used for fingerprinting purposes, each point in the <code>boundsGeometry</code> array may be rounded or adjusted by some amount. The specification recommends that browsers shift the points to the nearest 5 centimeters (while avoiding going outside the physical limitations of the hardware).</p>

<h3 id="Boundary_size">Boundary size</h3>

<p><code>XRBoundedReferenceSpace</code> is not intended to be used for very large bounded areas. Instead, it's meant to be used for one-room spaces with no more than around 15 meters of available movement space in any direction from the native origin. That said, the bounds extend upward indefinitely, since the bounds are defined in only two dimensions.</p>

<p>If you need to create a multi-room space, or a space which is very large or needs to have varying floor levels, you should instead use an unbounded {{domxref("XRReferenceSpace")}} and enforce the bounds on your own, as appropriate.</p>

<h3 id="Boundary_shape">Boundary shape</h3>

<p>The shape defined by <code>boundsGeometry</code> may be as simple as a square or as complex as is needed, potentially including concave and/or convex sections. However, you can't represent spaces with uneven floor levels using <code>XRBoundedReferenceSpace</code>. The ground is <em>always</em> at <code>y</code> = 0.</p>

<p>It's important that your content not be designed to require the user to exit the bounds specified by <code>boundsGeometry</code>. However, if the user's surroundings permit them to move in such a way as to exit the defined bounds, your content must be able to gracefully handle the situation, which is not considered an error condition.</p>

<p>Although some samples render a mesh or other shape to display the bounds to the user, in a real-world application, you shouldn't do this. The browser, however, should provide appropriate warnings to the user about any risks (such as the risk that they might run into a physical wall if they keep moving).</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebXR','#dom-xrboundedreferencespace-boundsgeometry','boundsGeometry')}}</td>
   <td>{{Spec2('WebXR')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">
<p>The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>
</div>

<p>{{Compat("api.XRBoundedReferenceSpace.boundsGeometry")}}</p>
